﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Section;
using Infragistics.Documents.Reports.Report.Text;
using Infragistics.Documents.Reports.Graphics;
using System.IO;
using System.Globalization;

namespace xamChartToPDF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Report theReport = new Report();

            ISection theSection = theReport.AddSection();

            IText theText = theSection.AddText();

            theText.AddContent("Chart Data");

            string theImgFile = 
                AppDomain.CurrentDomain.BaseDirectory + @"\theimg.png";


            SaveImage(theImgFile, this.xamDataChart1);

            theSection.AddImage(
                new Infragistics.Documents.Reports.Graphics.Image(theImgFile));


            string theFile = AppDomain.CurrentDomain.BaseDirectory + @"\thePDF.pdf";

            theReport.Publish(theFile, FileFormat.PDF);

            System.Diagnostics.Process.Start(theFile);

        }



        public static void SaveImage(string fileName, FrameworkElement element)
        {
            string imageExtension = 
                new FileInfo(fileName).Extension.ToLower(CultureInfo.InvariantCulture);

            BitmapEncoder imgEncoder = null;
            switch (imageExtension)
            {
                case ".bmp":
                    imgEncoder = new BmpBitmapEncoder();
                    break;

                case ".jpg":
                case ".jpeg":
                    imgEncoder = new JpegBitmapEncoder();
                    break;

                case ".png":
                    imgEncoder = new PngBitmapEncoder();
                    break;

                case ".gif":
                    imgEncoder = new GifBitmapEncoder();
                    break;

                case ".tif":
                case ".tiff":
                    imgEncoder = new TiffBitmapEncoder();
                    break;

                case ".wdp":
                    imgEncoder = new WmpBitmapEncoder();
                    break;

                default:
                    imgEncoder = new BmpBitmapEncoder();
                    break;
            }

            if (element != null)
            {
                RenderTargetBitmap bmpSource = 
                    new RenderTargetBitmap(
                        (int)element.ActualWidth, 
                        (int)element.ActualHeight, 96, 96, 
                        PixelFormats.Pbgra32);
                bmpSource.Render(element);

                imgEncoder.Frames.Add(BitmapFrame.Create(bmpSource));
                using (Stream stream = File.Create(fileName))
                {
                    imgEncoder.Save(stream);
                    stream.Close();
                }
            }
        }




    }








}





